Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkOBBTree Class Reference

`#include <vtkOBBTree.h>`

Inheritance diagram for vtkOBBTree:

[legend]
Collaboration diagram for vtkOBBTree:

[legend]
List of all members.

## Detailed Description

generate oriented bounding box (OBB) tree

Date:
  2002/11/03 22:51:55

Revision:
  1.40

vtkOBBTree is an object to generate oriented bounding box (OBB) trees. An oriented bounding box is a bounding box that does not necessarily line up along coordinate axes. The OBB tree is a hierarchical tree structure of such boxes, where deeper levels of OBB confine smaller regions of space.

To build the OBB, a recursive, top-down process is used. First, the root OBB is constructed by finding the mean and covariance matrix of the cells (and their points) that define the dataset. The eigenvectors of the covariance matrix are extracted, giving a set of three orthogonal vectors that define the tightest-fitting OBB. To create the two children OBB's, a split plane is found that (approximately) divides the number cells in half. These are then assigned to the children OBB's. This process then continues until the MaxLevel ivar limits the recursion, or no split plane can be found.

A good reference for OBB-trees is Gottschalk & Manocha in Proceedings of Siggraph `96.

Warning:
  Since this algorithms works from a list of cells, the OBB tree will only bound the "geometry" attached to the cells if the convex hull of the cells bounds the geometry.

Warning:
  Long, skinny cells (i.e., cells with poor aspect ratio) may cause unsatisfactory results. This is due to the fact that this is a top-down implementation of the OBB tree, requiring that one or more complete cells are contained in each OBB. This requirement makes it hard to find good split planes during the recursion process. A bottom-up implementation would go a long way to correcting this problem.

See also:
  vtkLocator vtkCellLocator vtkLocatorFilter

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (35%)
  - Warfield, Simon (26%)
  - Gobbi, David (21%)

CVS logs (CVSweb):
  - .`cxx` (`/Graphics/vtkOBBTree.cxx)`
  - .`h` (`/Graphics/vtkOBBTree.h)`

Tests:
  vtkOBBTree (Tests)

Definition at line 98 of file vtkOBBTree.h.

## Public Types
typedef vtkCellLocator | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
int | InsideOrOutside (const float point[3])
int | IntersectWithLine (float a0[3], float a1[3], float tol, float &t, float x[3], float pcoords[3], int &subId, vtkIdType &cellId)
int | IntersectWithLine (float a0[3], float a1[3], float tol, float &t, float x[3], float pcoords[3], int &subId, vtkIdType &cellId, vtkGenericCell *cell)
int | LineIntersectsNode (vtkOBBNode *pA, float B0[3], float B1[3])
void | GenerateRepresentation (int level, vtkPolyData *pd)
void | ComputeOBB (vtkPoints *pts, float corner[3], float max[3], float mid[3], float min[3], float size[3])
void | ComputeOBB (vtkDataSet *input, float corner[3], float max[3], float mid[3], float min[3], float size[3])
int | IntersectWithLine (const float a0[3], const float a1[3], vtkPoints *points, vtkIdList *cellIds)
int | IntersectWithLine (float a0[3], float a1[3], float tol, float &t, float x[3], float pcoords[3], int &subId)
int | DisjointOBBNodes (vtkOBBNode *nodeA, vtkOBBNode *nodeB, vtkMatrix4x4 *XformBtoA)
int | TriangleIntersectsNode (vtkOBBNode *pA, float p0[3], float p1[3], float p2[3], vtkMatrix4x4 *XformBtoA)
int | IntersectWithOBBTree (vtkOBBTree *OBBTreeB, vtkMatrix4x4 *XformBtoA, int(*function)(vtkOBBNode *nodeA, vtkOBBNode *nodeB, vtkMatrix4x4 *Xform, void *arg), void *data_arg)
void | FreeSearchStructure ()
void | BuildLocator ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkOBBTree * | SafeDownCast (vtkObject *o)
vtkOBBTree * | New ()
## Protected Methods
| vtkOBBTree ()
| ~vtkOBBTree ()
void | ComputeOBB (vtkIdList *cells, float corner[3], float max[3], float mid[3], float min[3], float size[3])
void | BuildTree (vtkIdList *cells, vtkOBBNode *parent, int level)
void | DeleteTree (vtkOBBNode *OBBptr)
void | GeneratePolygons (vtkOBBNode *OBBptr, int level, int repLevel, vtkPoints *pts, vtkCellArray *polys)
## Protected Attributes
vtkOBBNode * | Tree
vtkPoints * | PointsList
int * | InsertedPoints
int | OBBCount
int | DeepestLevel

## Member Typedef Documentation

typedef vtkCellLocator vtkOBBTree::Superclass

| Reimplemented from vtkCellLocator. Definition at line 101 of file vtkOBBTree.h.

## Constructor & Destructor Documentation

vtkOBBTree::vtkOBBTree | ( |  | ) | `[protected]`

vtkOBBTree::~vtkOBBTree | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkOBBTree::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkCellLocator.

int vtkOBBTree::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCellLocator.

virtual int vtkOBBTree::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCellLocator.

vtkOBBTree* vtkOBBTree::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkCellLocator.

vtkOBBTree* vtkOBBTree::New | ( |  | ) | `[static]`

| Construct with automatic computation of divisions, averaging 25 cells per octant. Reimplemented from vtkCellLocator.

void vtkOBBTree::ComputeOBB | ( | vtkPoints * | pts,
|  | float | corner[3],
|  | float | max[3],
|  | float | mid[3],
|  | float | min[3],
|  | float | size[3]
| ) |

| Compute an OBB from the list of points given. Return the corner point and the three axes defining the orientation of the OBB. Also return a sorted list of relative "sizes" of axes for comparison purposes.

void vtkOBBTree::ComputeOBB | ( | vtkDataSet * | input,
|  | float | corner[3],
|  | float | max[3],
|  | float | mid[3],
|  | float | min[3],
|  | float | size[3]
| ) |

| Compute an OBB for the input dataset using the cells in the data. Return the corner point and the three axes defining the orientation of the OBB. Also return a sorted list of relative "sizes" of axes for comparison purposes.

int vtkOBBTree::InsideOrOutside | ( | const float | point[3] | ) |

| Determine whether a point is inside or outside the data used to build this OBB tree. The data must be a closed surface vtkPolyData data set. The return value is +1 if outside, -1 if inside, and 0 if undecided.

int vtkOBBTree::IntersectWithLine | ( | const float | a0[3],
|  | const float | a1[3],
|  | vtkPoints * | points,
|  | vtkIdList * | cellIds
| ) |

| Take the passed line segment and intersect it with the data set. This method assumes that the data set is a vtkPolyData that describes a closed surface, and the intersection points that are returned in 'points' alternate between entrance points and exit points. The return value of the function is 0 if no intersections were found, -1 if point 'a0' lies inside the closed surface, or +1 if point 'a0' lies outside the closed surface. Either 'points' or 'cellIds' can be set to NULL if you don't want to receive that information.

int vtkOBBTree::IntersectWithLine | ( | float | a0[3],
|  | float | a1[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId
| ) | `[virtual]`

| Return the first intersection of the specified line segment with the OBB tree, as well as information about the cell which the line segment intersected. Reimplemented from vtkCellLocator.

int vtkOBBTree::IntersectWithLine | ( | float | a0[3],
|  | float | a1[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId,
|  | vtkIdType & | cellId
| ) | `[virtual]`

| Return intersection point (if any) AND the cell which was intersected by the finite line. Reimplemented from vtkCellLocator.

int vtkOBBTree::IntersectWithLine | ( | float | a0[3],
|  | float | a1[3],
|  | float | tol,
|  | float & | t,
|  | float | x[3],
|  | float | pcoords[3],
|  | int & | subId,
|  | vtkIdType & | cellId,
|  | vtkGenericCell * | cell
| ) | `[virtual]`

| Return intersection point (if any) AND the cell which was intersected by the finite line. The cell is returned as a cell id and as a generic cell. Reimplemented from vtkCellLocator.

int vtkOBBTree::DisjointOBBNodes | ( | vtkOBBNode * | nodeA,
|  | vtkOBBNode * | nodeB,
|  | vtkMatrix4x4 * | XformBtoA
| ) |

| Returns true if nodeB and nodeA are disjoint after optional transformation of nodeB with matrix XformBtoA

int vtkOBBTree::LineIntersectsNode | ( | vtkOBBNode * | pA,
|  | float | B0[3],
|  | float | B1[3]
| ) |

| Returns true if line intersects node.

int vtkOBBTree::TriangleIntersectsNode | ( | vtkOBBNode * | pA,
|  | float | p0[3],
|  | float | p1[3],
|  | float | p2[3],
|  | vtkMatrix4x4 * | XformBtoA
| ) |

| Returns true if triangle (optionally transformed) intersects node.

int vtkOBBTree::IntersectWithOBBTree | ( | vtkOBBTree * | OBBTreeB,
|  | vtkMatrix4x4 * | XformBtoA,
|  | int(* | function)(vtkOBBNode *nodeA, vtkOBBNode *nodeB, vtkMatrix4x4 *Xform, void *arg),
|  | void * | data_arg
| ) |

| For each intersecting leaf node pair, call function. OBBTreeB is optionally transformed by XformBtoA before testing.

void vtkOBBTree::FreeSearchStructure | ( |  | ) | `[virtual]`

| Satisfy locator's abstract interface, see vtkLocator. Reimplemented from vtkCellLocator.

void vtkOBBTree::BuildLocator | ( |  | ) | `[virtual]`

| Satisfy locator's abstract interface, see vtkLocator. Reimplemented from vtkCellLocator.

void vtkOBBTree::GenerateRepresentation | ( | int | level,
|  | vtkPolyData * | pd
| ) | `[virtual]`

| Create polygonal representation for OBB tree at specified level. If level < 0, then the leaf OBB nodes will be gathered. The aspect ratio (ar) and line diameter (d) are used to control the building of the representation. If a OBB node edge ratio's are greater than ar, then the dimension of the OBB is collapsed (OBB->plane->line). A "line" OBB will be represented either as two crossed polygons, or as a line, depending on the relative diameter of the OBB compared to the diameter (d). Reimplemented from vtkCellLocator.

void vtkOBBTree::ComputeOBB | ( | vtkIdList * | cells,
|  | float | corner[3],
|  | float | max[3],
|  | float | mid[3],
|  | float | min[3],
|  | float | size[3]
| ) | `[protected]`

void vtkOBBTree::BuildTree | ( | vtkIdList * | cells,
|  | vtkOBBNode * | parent,
|  | int | level
| ) | `[protected]`

void vtkOBBTree::DeleteTree | ( | vtkOBBNode * | OBBptr | ) | `[protected]`

void vtkOBBTree::GeneratePolygons | ( | vtkOBBNode * | OBBptr,
|  | int | level,
|  | int | repLevel,
|  | vtkPoints * | pts,
|  | vtkCellArray * | polys
| ) | `[protected]`

## Member Data Documentation

vtkOBBNode* vtkOBBTree::Tree`[protected]`

| Reimplemented from vtkCellLocator. Definition at line 218 of file vtkOBBTree.h.

vtkPoints* vtkOBBTree::PointsList`[protected]`

| Definition at line 220 of file vtkOBBTree.h.

int* vtkOBBTree::InsertedPoints`[protected]`

| Definition at line 221 of file vtkOBBTree.h.

int vtkOBBTree::OBBCount`[protected]`

| Definition at line 222 of file vtkOBBTree.h.

int vtkOBBTree::DeepestLevel`[protected]`

| Definition at line 223 of file vtkOBBTree.h.

The documentation for this class was generated from the following file:

- Graphics/vtkOBBTree.h